#include <iostream>
#include "examplewindow.h"

ExampleWindow::ExampleWindow()
: m_Scale()
{
  set_title ("EventBox");
  set_border_width(10);

  add(m_EventBox);

  m_EventBox.add(m_Scale);

  // makes no difference
  m_EventBox.set_visible_window(true);

  // doesn't help either
  //m_Scale.set_events(Gdk::BUTTON_PRESS_MASK | Gdk::BUTTON_RELEASE_MASK);

  // this puts the EventBox on top, which makes the events always fire, but
  // the underlying element never receives them unless you send them manually
  // using m_Scale.event().
  //m_EventBox.set_above_child(true);

  //Clip the label short:
  m_Scale.set_size_request(110, 40);
  m_Scale.set_range(0,100);

  //And bind an action to it:
  m_EventBox.set_events(Gdk::BUTTON_PRESS_MASK | Gdk::BUTTON_RELEASE_MASK);

  //m_EventBox.signal_button_press_event().connect(
  //  sigc::mem_fun(*this, &ExampleWindow::on_eventbox_button_press) );

  // this should make the event always fire. but it still doesn't.
  m_EventBox.signal_button_press_event().connect(
    sigc::mem_fun(*this, &ExampleWindow::on_eventbox_button_press), false );

  //m_EventBox.signal_button_release_event().connect(
  //  sigc::mem_fun(*this, &ExampleWindow::on_eventbox_button_release) );

  m_EventBox.signal_button_release_event().connect(
    sigc::mem_fun(*this, &ExampleWindow::on_eventbox_button_release), false );

  m_EventBox.set_tooltip_text("Click me!");

  show_all_children();
}

ExampleWindow::~ExampleWindow()
{
}

bool ExampleWindow::on_eventbox_button_press(GdkEventButton* event)
{
  std::cout << "pressed" << std::endl;
  // this will make the scale below clickable even if set_above_child(true)
  // but if you do this the button_release of the EventBox does not fire !!
  //m_Scale.event((GdkEvent*)event);
  // "If the value is false then gtkmm will pass the event on to the next signal handler."
  // http://library.gnome.org/devel/gtkmm-tutorial/unstable/sec-xeventsignals.html.en
  return false;
}

bool ExampleWindow::on_eventbox_button_release(GdkEventButton*)
{
  std::cout << "release" << std::endl;
  return false;
}
